;game intro

Intro
	
;--screen1---
	CALL ClearScreen
	LD HL,18566
	LD DE,IntroText1
	CALL TypeText
	CALL Wait2Seconds
		
	LD HL,22918
	LD BC, 256*23+1
	CALL FadeOut1
	
	
;---screen2-------
;graphics
	CALL DrawIntroPic1

;----------------------
;text
	LD HL,18624
	LD DE,IntroText2
	CALL TypeText
	CALL IntroWaitForKey; when key is pressed makes fadeout with text which clears it
	
;text
	LD HL,20480
	LD DE,IntroText3
	CALL TypeText
	CALL IntroWaitForKey
	
;text
	LD HL,20480
	LD DE,IntroText4
	CALL TypeText
	CALL IntroWaitForKey

;text
	LD HL,20480
	LD DE,IntroText5
	CALL TypeText
	CALL IntroWaitForKey
 
;--------screen3
 	
;graphics: draw hotel entrance
	CALL ClearScreen	

	LD BC,21*256+12
	LD HL,16390
	CALL DrawBox
	
	LD HL,16429
	LD DE,BlueBrick
	LD BC,13*256+8
	CALL TileBlock
	
	LD HL,16466
	LD DE,GlassDoor1
	LD BC,3*256+4
	CALL TileBlock
	
	LD HL,16465
	LD DE,GoldEdgeL
	LD BC,1*256+7
	CALL TileBlock
	
	LD HL,16471
	LD DE,GoldEdgeR
	LD BC,1*256+7
	CALL TileBlock
	
	LD HL,16434
	LD DE,GoldEdgeT
	LD BC,5*256+1
	CALL TileBlock
	
	LD HL,16468
	LD DE,GlassDoor2
	LD BC,1*256+2
	CALL TileBlock
	
	LD HL,18471
	LD DE,Pavement
	LD BC,19*256+1
	CALL TileBlock
	
	
	LD DE,OldCar
	LD HL,16551
	CALL DrawTile
	
	LD DE,GoldEdgeLC
	LD HL,16433
	CALL DrawTile
	
	LD DE,GoldEdgeRC
	LD HL,16439
	CALL DrawTile
	
	LD HL,16531
	LD DE,OldMan2
	CALL DrawTile
;--------------
;text
	LD HL,20480
	LD DE,IntroText6
	CALL TypeText
	CALL IntroWaitForKey
	
;text
	LD HL,20480
	LD DE,IntroText7
	CALL TypeText
	CALL IntroWaitForKey
;----screen 4
	CALL ClearScreen
	LD BC,17*256+14
	LD HL,16391
	CALL DrawBox
	
	LD HL,16425
	LD DE,LiftBrick1
	LD BC,1*256+6
	CALL TileBlock
	
	LD HL,16434
	LD DE,LiftBrick1
	LD BC,1*256+6
	CALL TileBlock
	
	LD HL,16427
	LD DE,Brick01
	LD BC,1*256+6
	CALL TileBlock
	
	LD HL,16436
	LD DE,Brick01
	LD BC,1*256+6
	CALL TileBlock
	
	LD BC,2*256+12
	LD DE,22571
	LD A,72
	CALL AttrBlock
	
	LD BC,2*256+12
	LD DE,22580
	LD A,72
	CALL AttrBlock
	
	
	
	LD HL,16434
	LD BC,4*256+12
	CALL MirrorArea
	
	LD HL,16431
	LD DE,Rope
	LD BC,1*256+3
	CALL TileBlock
	
	LD HL,16525
	LD DE,Stairs03
	LD BC,5*256+8
	CALL TileBlock
	
	LD BC,5*256+6
	LD DE,22701
	LD A,73
	CALL AttrBlock
	
	LD DE,OldMan1
	LD HL,16558
	CALL DrawTile
;----------	
	;text
	LD HL,20480
	LD DE,IntroText8
	CALL TypeText
	CALL IntroWaitForKey
	
	;text
	LD HL,20480
	LD DE,IntroText9
	CALL TypeText
	CALL IntroWaitForKey

;------screen 4
	CALL DrawIntroPic1
	
	;text
	LD HL,20480
	LD DE,IntroText10
	CALL TypeText
	CALL IntroWaitForKey
	
	;text
	LD HL,20480
	LD DE,IntroText11
	CALL TypeText
	CALL IntroWaitForKey
	
	;text
	LD HL,20480
	LD DE,IntroText12
	CALL TypeText
	CALL IntroWaitForKey
	
	;text
	LD HL,20480
	LD DE,IntroText13
	CALL TypeText
	CALL IntroWaitForKey

	;text
	LD HL,20480
	LD DE,IntroText14
	CALL TypeText
	CALL IntroWaitForKey
	
	JP StartMenu
;-------------
FadeOut
;fade out colors in a defined rectangle to black
;HL - left upper corner, BC - rectangle size
;can be executed with default values by CALL FadeOut
;or with custom values by CALL FadeOut1
	LD HL,22976
	LD BC,32*256+10

FadeOut1	
	PUSH HL
	PUSH BC
	
	LD D,0; are there any square left to fade out? 0-no, 1-yes
	
	
	;line of squares
FadeOut2
	
	LD A, (HL) ;get attributes
	AND 00000111B; extract ink
	OR A; do we still need to fade out?
	JR Z, FadeOut3; no need
	
	;do fade out
	DEC A; change color to darker one
	INC D; mark that fadeout was done
	LD E,A
	LD A,(HL)
	AND 11111000B
	OR E; merge ink with rest of attribute
	LD (HL),A
	
FadeOut3
	INC HL; go to next square
	DJNZ FadeOut2
	
	;go to new line
	LD E,C
	POP BC
	PUSH BC
	LD C,E ;restore B while keeping C
	
	LD A,L
	SUB B; go to the beginning of line
		
	ADD A,32;go to beginning of new line
	LD L,A
	JR NC, FadeOut4; not going to next screen segment
	
	LD A,H; going to next screen segment
	ADD A,8
	LD A,H

FadeOut4
	DEC C
	JR NZ, FadeOut2
		
;delay	
	LD E,6
FadeOut5
	HALT
	DEC E
	JR NZ,FadeOut5
	
	POP BC
	POP HL
	
	LD A,D
	OR A; were any fadeout done in this round?
	JR NZ,FadeOut1 ; if so, repeat
	
	RET
;-------------------
IntroWaitForKey
		CALL WaitForPressFireNoSound
		CALL FadeOut; make fadeout with existing text
		RET

;-------------------
DrawIntroPic1
	CALL ClearScreen	

	LD BC,21*256+13
	LD HL,16390
	CALL DrawBox
	
	LD HL,18503
	LD DE,Pavement
	LD BC,256*19+1
	CALL TileBlock
	
	LD HL,16470
	LD DE,RonEnd
	CALL DrawTile
	
	LD HL,18471
	LD DE,BottleIntro
	CALL DrawTile
	
	LD HL,16526
	LD DE,City01
	CALL DrawTile
	
	LD HL,16461
	LD DE,WindowIntro1
	CALL DrawTile
	
	LD HL,16467
	LD DE,WindowIntro1
	CALL DrawTile
	
	LD HL,16467
	LD BC,2*256+6
	CALL MirrorArea
	
	LD DE,Brick04
	LD HL,16488
	CALL DrawTile
	
	LD HL,16463
	LD DE,WindowIntro2
	LD BC,4*256+1
	CALL TileBlock
	
	LD HL,16623
	LD DE,WindowIntro2
	LD BC,4*256+1
	CALL TileBlock
	RET


;-------------------

IntroText1
	.BYTE 13,9,4,14,9,7,8,20,27,3,9,20,25,50,27,32,30,33,31,0; Midnight City 2031
IntroText2
	.BYTE 	9,20,27,1,12,12,27,2,5,7,1,14,27,1,20,27,15,14,5,27,19,12,5,5,16,12,5,19,19,63,14,9,7,8,20,47,63,63		;IT ALL BEGAN AT ONE SLEEPLESS NIGHT...									
	.BYTE 13,25,27,14,1,13,5,27,9,19,27,18,15,14,27,8,1,18,4,25,50,1,7,5,4,27,33,33,28,9,48,13,63,10,21,19,20,27,1,27,14,15,18,13,1,12,27,7,21,25,28 ;MY NAME IS RON HARDY, AGED 33. I M JUST A NORMAL GUY.
	.BYTE 1,20,27,12,5,1,19,20,27,9,63,12,9,11,5,27,20,15,27,2,5,12,9,5,22,5,27,9,14,27,9,20,28,63;AT LEAST I LIKE TO BELIEVE IN IT.
														
	.BYTE 9,27,20,18,9,5,4,27,13,1,14,25,27,10,15,2,19,27,1,14,4,27,13,1,14,25,27,23,15,13,5,14,63;I TRIED MANY JOBS AND MANY WOMEN  IN MY LIFE BUT EVERY TIME IT WAS A FAILURE
	.BYTE 9,14,27,13,25,27,12,9,6,5,27,2,21,20,27,5,22,5,18,25,27,20,9,13,5,27
	.BYTE 9,20,27,23,1,19,63,1,27,6,1,9,12,21,18,5,28,63,0
IntroText3
	.BYTE 9,19,14,48,20,27,9,20,27,9,18,15,14,9,3,40,27,23,5,27,8,1,22,5,27,6,12,25,9,14,7,63;ISN T IT IRONIC WE HAVE FLYING CARS ZETTABYTES OF COMPUTER MEMORY
	.BYTE 3,1,18,19,50,26,5,20,20,1,2,25,20,5,19,27,15,6,27,3,15,13,16,21,20,5,18,63,13,5,13,15,18,25,27
	.BYTE 1,14,4,27,19,5,24,27,18,15,2,15,20,19,27,2,21,20,27,23,5,63,19,20,9,12,12,27;AND SEX ROBOTS BUT WE STILL STRUGGLE TO FIND LOVE AND MEANING OF LIFE.
	.BYTE 19,20,18,21,7,7,12,5,27,20,15,27,6,9,14,4,27,12,15,22,5,27,1,14,4,63
	.BYTE 13,5,1,14,9,14,7,27,15,6,27,12,9,6,5,28,0																			
	
IntroText4
 .BYTE 23,8,5,14,27,9,20,27,8,1,16,16,5,14,5,4,27,9,27,12,9,22,5,4,27,9,14,63;WHEN IT HAPPENED I LIVED IN
 .BYTE 18,21,9,14,5,4,50,8,1,12,6,27,4,5,19,5,18,20,5,4,27,19,11,25,19,3,18,1,16,5,18,63 ;RUINED,HALF DESERTED SKYSCRAPER
 .BYTE 9,14,27,13,9,4,14,9,7,8,20,27,3,9,20,25,27,15,12,4,27,4,15,23,14,20,15,23,14,28,9,20,63 ;IN MIDNIGHT CITY OLD DOWNTOWN.
 .BYTE 8,1,4,27,2,5,5,14,27,12,21,24,21,18,9,15,21,19,27,8,15,20,5,12,27,15,14,3,5,63;IT'D BEEN LUXURIOUS HOTEL ONCE
 .BYTE 2,21,20,27,14,15,23,27,9,20,27,23,1,19,27,15,14,12,25,27,1,27,2,9,20,20,5,18,63;BUT NOW IT WAS ONLY A BITTER
 .BYTE 19,8,1,4,15,23,27,15,6,27,9,20,19,27,6,15,18,13,5,18,27,7,12,15,18,25,28,0; SHADOW OF ITS FORMER GLORY.
 
IntroText5
 .BYTE 9,27,8,1,4,27,18,5,1,4,27,2,5,6,15,18,5,27,1,2,15,21,20,27,5,22,5,14,20,19,63;I HAD READ BEFORE ABOUT EVENTS
 .BYTE 23,8,9,3,8,27,20,18,9,7,7,5,18,5,4,27,20,8,5,27,6,1,12,12,27,15,6,27,13,25,63;WHICH TRIGGERED THE FALL OF MY
 .BYTE 16,12,1,3,5,28,5,24,1,3,20,12,25,27,31,30,30,27,25,5,1,18,19,27,16,1,19,19,5,4,63;PLACE.EXACTLY 100 YEARS PASSED
 .BYTE 19,9,14,3,5,27,20,8,5,14,27,2,21,20,27,20,8,9,14,7,19,27,19,20,9,12,12,63;SINCE THEN BUT THINGS STILL
 .BYTE 18,5,13,1,9,14,5,4,27,1,14,27,21,14,19,15,12,22,5,4,27,5,14,9,7,13,1,28,0;REMAINED AN UNSOLVED ENIGMA.
 
IntroText6
 .BYTE 9,20,27,23,1,19,27,1,27,4,1,18,11,50,23,9,14,4,25,27,14,9,7,8,20,27,9,14,63;IT WAS A DARK,WINDY NIGHT IN
 .BYTE 31,39,33,31,27,23,8,5,14,27,1,14,27,15,12,4,50,8,15,13,5,12,5,19,19,27,13,1,14,63;1931 WHEN AN OLD,HOMELESS MAN
 .BYTE 1,16,16,18,15,1,3,8,5,4,27,20,8,5,27,19,8,9,14,9,14,7,27,7,1,20,5,19,63;APPROACHED THE SHINING GATES
 .BYTE 15,6,27,49,16,18,21,4,5,14,20,9,1,12,49,27,8,15,20,5,12,28,0;OF "PRUDENTIAL" HOTEL.
 
IntroText7
 .BYTE 20,8,5,27,19,20,15,18,25,27,7,15,5,19,27,2,9,26,1,18,18,5,27,8,5,18,5,28,27,20,8,5,63;THE STORY GOES BIZARRE HERE. THE
 .BYTE 8,15,20,5,12,27,19,20,1,6,6,27,20,18,9,5,4,27,20,15,27,20,8,18,15,23,27,8,9,13,63;HOTEL STAFF TRIED TO THROW HIM
 .BYTE 15,21,20,27,2,21,20,27,14,5,9,20,8,5,18,27,23,15,18,4,19,50,6,9,19,20,19,27,14,15,18,63;OUT BUT NEITHER WORDS FISTS NOR
 .BYTE 5,22,5,14,27,2,21,12,12,5,20,19,27,3,15,21,12,4,27,19,20,15,16,27,8,9,13,28,63;EVEN BULLETS COULD STOP HIM.
 .BYTE 49,8,5,27,23,1,19,27,12,9,11,5,27,19,21,16,5,18,13,1,14,49,27,19,1,9,4,27,15,14,5,63;"HE WAS LIKE SUPERMAN" SAID ONE
 .BYTE 15,6,27,20,8,5,13,28,0;OF THEM.
 

IntroText8
 .BYTE 8,5,27,23,1,12,11,5,4,27,9,14,20,15,27,1,27,16,18,9,22,1,20,5,27,12,9,6,20,63;HE WALKED INTO A PRIVATE LIFT
 .BYTE 23,8,9,3,8,27,23,5,14,20,27,19,20,18,1,9,7,8,20,27,20,15,27,20,8,5,27,20,15,16,63;WHICH WENT STRAIGHT TO THE TOP
 .BYTE 6,12,15,15,18,28,63;FLOOR.
 .BYTE 20,8,5,27,5,14,20,9,18,5,27,6,12,15,15,18,27,23,1,19,27,15,3,3,21,16,9,5,4,63;THE ENTIRE FLOOR WAS OCCUPIED
 .BYTE 2,25,27,12,21,3,18,5,20,9,1,27,4,5,27,19,1,14,20,9,19,50,1,27,18,9,3,8,63;BY LUCRETIA DE SANTIS A RICH
 .BYTE 1,14,4,27,13,25,19,20,5,18,9,15,21,19,27,23,15,13,1,14,28,0;AND MYSTERIOUS WOMAN.
 
IntroText9
 .BYTE 14,15,2,15,4,25,27,11,14,15,23,19,27,23,8,1,20,27,8,1,16,16,5,14,5,4,27,20,8,5,18,5,63;NOBODY KNOWS WHAT HAPPENED THERE
 .BYTE 2,21,20,27,8,5,27,1,16,16,1,18,5,14,20,12,25,27,1,20,20,1,3,11,5,4,27,4,5,63;BUT HE APPARENTLY ATTACKED DE
 .BYTE 19,1,14,20,9,19,28,20,8,5,25,27,19,20,18,21,7,7,12,5,4,27,1,14,4,27,6,5,12,12,27,63;SANTIS.THEY STRUGGLED AND FELL 
 .BYTE 20,8,18,15,21,7,8,27,20,8,5,27,23,9,14,4,15,23,28,27,2,15,20,8,27,15,6,27,20,8,5,13,63;THROUGH THE WINDOW. BOTH OF THEM
 .BYTE 4,9,5,4,27,1,14,4,27,23,5,18,5,27,2,21,18,9,5,4,28,9,4,5,14,20,9,20,25,63;DIED AND WERE BURIED.IDENTITY
 .BYTE 15,6,27,20,8,5,27,9,14,20,18,21,4,5,18,27,18,5,13,1,9,14,19,27,21,14,11,14,15,23,14,28,0;OF THE INTRUDER REMAINS UNKNOWN.
 
IntroText10
  .BYTE 9,20,27,14,5,22,5,18,27,13,1,4,5,27,1,14,25,27,19,5,14,19,5,27,20,15,27,13,5,28,63;IT NEVER MADE ANY SENSE TO ME.
  .BYTE 23,8,25,27,23,15,21,12,4,27,1,27,19,21,16,5,18,8,5,18,15,27,8,15,2,15,27,19,20,15,18,13,63;WHY WOULD A SUPERHERO HOBO STORM
  .BYTE 20,8,5,27,8,15,20,5,12,27,1,14,4,27,4,5,6,5,1,20,27,36,27,1,18,13,5,4,27,63;THE HOTEL AND DEFEAT 6 ARMED 
  .BYTE 13,5,14,27,15,14,12,25,27,20,15,27,1,19,19,1,21,12,20,27,1,14,27,8,9,7,8,63;MEN ONLY TO ASSAULT AN HIGH
  .BYTE 19,15,3,9,5,20,25,27,12,1,4,25,40,27,8,5,27,4,9,4,14,48,20,27,19,5,5,11,27,27,63;SOCIETY LADY?  HE DIDN T SEEK 
  .BYTE 13,15,14,5,25,28,27,23,8,1,20,27,4,9,4,27,8,5,27,19,5,5,11,40,0;MONEY. WHAT DID HE SEEK?
 
IntroText11 
 .BYTE 19,9,14,3,5,27,20,8,5,14,27,20,8,5,27,8,15,20,5,12,27,6,5,12,12,27,9,14,20,15,63;SINCE THEN THE HOTEL FELL INTO
 .BYTE 4,5,3,1,25,28,27,9,20,27,23,1,19,27,19,1,9,4,27,20,15,27,2,5,27,4,1,13,14,5,4,63;DECAY. IT WAS SAID TO BE DAMNED
 .BYTE 1,14,4,27,8,1,21,14,20,5,4,27,16,12,1,3,5,28,21,14,5,24,16,12,1,9,14,5,4,63;AND HAUNTED PLACE.UNEXPLAINED
 .BYTE 4,5,1,20,8,19,50,19,21,9,3,9,4,5,19,50,19,3,18,5,1,13,19,27,6,18,15,13,63;DEATHS SUICIDES SCREAMS FROM
 .BYTE 5,13,16,20,25,27,18,15,15,13,19,28,9,27,8,1,4,27,8,5,1,18,4,27,19,20,18,1,14,7,5,63;EMPTY ROOMS.I HAD HEARD STRANGE
 .BYTE 22,15,9,3,5,19,27,13,25,19,5,12,6,28,0;VOICES MYSELF.
  
IntroText12
 .BYTE 20,8,5,27,20,15,16,27,6,12,15,15,18,27,23,1,19,27,2,15,1,18,4,5,4,27,21,16,50,63;THE TOP FLOOR WAS BOARDED UP,
 .BYTE 19,20,1,9,18,19,27,1,14,4,27,12,9,6,20,19,27,23,5,18,5,27,4,5,19,20,18,15,25,5,4,27,63;STAIRS AND LIFTS WERE DESTROYED 
 .BYTE 10,21,19,20,27,12,9,11,5,27,19,15,13,5,20,8,9,14,7,27,5,22,9,12,27,4,23,5,12,12,5,4,63;JUST LIKE SOMETHING EVIL DWELLED
 .BYTE 20,8,5,18,5,28,9,27,8,1,4,27,8,5,1,18,4,27,19,20,15,18,9,5,19,27,15,6,63;THERE.I HAD HEARD STORIES OF
 .BYTE 12,15,15,20,5,18,19,27,20,18,25,9,14,7,27,20,15,27,18,15,2,27,9,20,27,1,14,4,63;LOOTERS TRYING TO ROB IT AND
 .BYTE 14,5,22,5,18,27,18,5,20,21,18,14,9,14,7,28,0;NEVER RETURNING.
 
 
IntroText13
 .BYTE 20,8,5,27,19,11,25,19,3,18,1,16,5,18,27,8,1,4,27,2,5,3,15,13,5,27,1,63;THE SKYSCRAPER HAD BECOME A
 .BYTE 18,21,9,14,27,1,14,4,27,8,1,14,7,15,21,20,27,6,15,18,27,8,21,13,1,14,63;RUIN AND HANGOUT FOR HUMAN
 .BYTE 23,18,5,3,11,19,28,27,20,8,5,27,18,5,19,9,4,5,14,20,19,27,23,5,18,5,14,48,20,63;WRECKS. THE RESIDENTS WEREN'T
 .BYTE 3,21,18,9,15,21,19,27,1,2,15,21,20,27,9,20,19,27,7,12,15,15,13,25,27,16,1,19,20,28,63;CURIOUS ABOUT ITS GLOOMY PAST.
 .BYTE 23,5,27,1,12,12,27,8,1,4,27,5,14,15,21,7,8,27,16,18,15,2,12,5,13,19,27,9,14,63;WE ALL HAD ENOUGH PROBLEMS IN
 .BYTE 15,21,18,27,20,1,14,7,12,5,4,27,12,9,22,5,19,28,0;OUR TANGLED LIVES.
  
 
IntroText14
 .BYTE 13,25,27,20,8,15,21,7,8,20,19,27,23,5,18,5,27,1,2,18,21,16,20,12,25,63;MY THOUGHTS WERE ABRUPTLY
 .BYTE 9,14,20,5,18,18,21,16,20,5,4,27,2,25,27,1,27,14,15,9,19,5,27,23,8,9,3,8,63;INTERRUPTED BY A NOISE WHICH
 .BYTE 3,1,13,5,27,6,18,15,13,27,1,2,15,22,5,27,6,12,15,15,18,19,27,1,14,4,63;CAME FROM ABOVE FLOORS AND
 .BYTE 19,15,21,14,4,5,4,27,12,9,11,5,27,1,27,12,1,19,5,18,27,19,8,15,20,28,63;SOUNDED LIKE A LASER SHOT.
 .BYTE 1,27,23,8,9,12,5,27,12,1,20,5,18,27,9,27,6,5,12,20,27,8,5,1,20,27,1,14,4,63;WHILE LATER I FELT HEAT AND
 .BYTE 19,13,5,12,12,5,4,27,19,13,15,11,5,28,27,20,8,5,27,2,21,9,12,4,9,14,7,27,23,1,19,63;SMELLED SMOKE. THE BUILDING WAS
 .BYTE 15,14,27,6,9,18,5,47,0;ON FIRE...
 
 
 .BYTE 0