

StartMenu
;drawing start game menu	
	CALL ClearScreen
	
;type texts	
	LD HL,16552
	LD DE,StartMenuText1
	CALL TypeText
	
	LD HL,18503
	LD DE,StartMenuText2
	CALL TypeText

	LD HL,20643
	LD DE,StartMenuText3
	CALL TypeText
	
MenuControl	
;testing keyboard
	LD BC,63486
	IN A,(C)
		
	PUSH AF
	BIT 0,A 		;1 - choose keys
	JR Z,SetKeys
	POP AF
		
	PUSH AF
	BIT 1,A 		;2 - choose joystick	
	JR Z,SetJoystick
	POP AF
			
	PUSH AF
	BIT 2,A 		;3 - type intro
	JP Z,Intro
	
	POP AF
	BIT 3,A 		;4 - start game
	JP Z,Start2
	
	JR MenuControl
	
;-----------
SetKeys
	XOR A
	LD (GameControl),A	;store chosen control
	CALL SoundA
	JR MenuControl;
	
SetJoystick
	LD A,1
	LD (GameControl),A	;store chosen control
	CALL SoundA
	JR MenuControl

StartMenuText1
	.BYTE 51,66,19,11,25,19,3,18,1,16,5,18,27,15,6,27,4,15,15,13,0

StartMenuText2
	.BYTE 31,27,11,5,25,2,15,1,18,4,27,17,1,15,16,27,19,16,1,3,5,63
	.BYTE 32,27,11,5,13,16,19,20,15,14,27,10,15,25,19,20,9,3,11,63
	.BYTE 33,27,9,14,20,18,15,4,21,3,20,9,15,14,63
	.BYTE 34,27,19,20,1,18,20,27,7,1,13,5,63,63,63,0
	
StartMenuText3
	.BYTE 51,70,7,1,13,5,27,2,25,27,18,1,6,1,46,27,13,9,1,26,7,1,27,32,30,30,39,0


